# Cloud Bigtable Admin API

Administer your Cloud Bigtable tables and instances.

## Service: bigtableadmin.googleapis.com

To call this service, we recommend that you use the Google-provided [client libraries](https://cloud.google.com/apis/docs/client-libraries-explained). If your application needs to use your own libraries to call this service, use the following information when you make the API requests.

### Discovery document

A [Discovery Document](https://developers.google.com/discovery/v1/reference/apis) is a machine-readable specification for describing and consuming REST APIs. It is used to build client libraries, IDE plugins, and other tools that interact with Google APIs. One service may provide multiple discovery documents. This service provides the following discovery document:

- <https://bigtableadmin.googleapis.com/$discovery/rest?version=v2>

### Service endpoint

A [service endpoint](https://cloud.google.com/apis/design/glossary#api_service_endpoint) is a base URL that specifies the network address of an API service. One service might have multiple service endpoints. This service has the following service endpoint and all URIs below are relative to this service endpoint:

- `https://bigtableadmin.googleapis.com`

## REST Resource: [v2.operations](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/operations)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/operations/get` | `GET /v2/{name=operations/**}` Gets the latest state of a long-running operation. |

## REST Resource: [v2.operations.projects.operations](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/operations.projects.operations)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/operations.projects.operations/list` | `GET /v2/{name=operations/projects/**}/operations` Lists operations that match the specified filter in the request. |

## REST Resource: [v2.projects.instances](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances/create` | `POST /v2/{parent=projects/*}/instances` Create an instance within a project. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances/delete` | `DELETE /v2/{name=projects/*/instances/*}` Delete an instance from a project. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances/get` | `GET /v2/{name=projects/*/instances/*}` Gets information about an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances/getIamPolicy` | `POST /v2/{resource=projects/*/instances/*}:getIamPolicy` Gets the access control policy for an instance resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances/list` | `GET /v2/{parent=projects/*}/instances` Lists information about instances in a project. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances/partialUpdateInstance` | `PATCH /v2/{instance.name=projects/*/instances/*}` Partially updates an instance within a project. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances/setIamPolicy` | `POST /v2/{resource=projects/*/instances/*}:setIamPolicy` Sets the access control policy on an instance resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances/testIamPermissions` | `POST /v2/{resource=projects/*/instances/*}:testIamPermissions` Returns permissions that the caller has on the specified instance resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances/update` | `PUT /v2/{name=projects/*/instances/*}` Updates an instance within a project. |

## REST Resource: [v2.projects.instances.appProfiles](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.appProfiles)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.appProfiles/create` | `POST /v2/{parent=projects/*/instances/*}/appProfiles` Creates an app profile within an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.appProfiles/delete` | `DELETE /v2/{name=projects/*/instances/*/appProfiles/*}` Deletes an app profile from an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.appProfiles/get` | `GET /v2/{name=projects/*/instances/*/appProfiles/*}` Gets information about an app profile. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.appProfiles/list` | `GET /v2/{parent=projects/*/instances/*}/appProfiles` Lists information about app profiles in an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.appProfiles/patch` | `PATCH /v2/{appProfile.name=projects/*/instances/*/appProfiles/*}` Updates an app profile within an instance. |

## REST Resource: [v2.projects.instances.clusters](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters/create` | `POST /v2/{parent=projects/*/instances/*}/clusters` Creates a cluster within an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters/delete` | `DELETE /v2/{name=projects/*/instances/*/clusters/*}` Deletes a cluster from an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters/get` | `GET /v2/{name=projects/*/instances/*/clusters/*}` Gets information about a cluster. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters/getMemoryLayer` | `GET /v2/{name=projects/*/instances/*/clusters/*/memoryLayer}` Gets information about the memory layer of a cluster. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters/list` | `GET /v2/{parent=projects/*/instances/*}/clusters` Lists information about clusters in an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters/partialUpdateCluster` | `PATCH /v2/{cluster.name=projects/*/instances/*/clusters/*}` Partially updates a cluster within a project. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters/update` | `PUT /v2/{name=projects/*/instances/*/clusters/*}` Updates a cluster within an instance. |

## REST Resource: [v2.projects.instances.clusters.backups](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.backups)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.backups/copy` | `POST /v2/{parent=projects/*/instances/*/clusters/*}/backups:copy` Copy a Cloud Bigtable backup to a new backup in the destination cluster located in the destination instance and project. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.backups/create` | `POST /v2/{parent=projects/*/instances/*/clusters/*}/backups` Starts creating a new Cloud Bigtable Backup. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.backups/delete` | `DELETE /v2/{name=projects/*/instances/*/clusters/*/backups/*}` Deletes a pending or completed Cloud Bigtable backup. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.backups/get` | `GET /v2/{name=projects/*/instances/*/clusters/*/backups/*}` Gets metadata on a pending or completed Cloud Bigtable Backup. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.backups/getIamPolicy` | `POST /v2/{resource=projects/*/instances/*/clusters/*/backups/*}:getIamPolicy` Gets the access control policy for a Bigtable resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.backups/list` | `GET /v2/{parent=projects/*/instances/*/clusters/*}/backups` Lists Cloud Bigtable backups. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.backups/patch` | `PATCH /v2/{backup.name=projects/*/instances/*/clusters/*/backups/*}` Updates a pending or completed Cloud Bigtable Backup. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.backups/setIamPolicy` | `POST /v2/{resource=projects/*/instances/*/clusters/*/backups/*}:setIamPolicy` Sets the access control policy on a Bigtable resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.backups/testIamPermissions` | `POST /v2/{resource=projects/*/instances/*/clusters/*/backups/*}:testIamPermissions` Returns permissions that the caller has on the specified Bigtable resource. |

## REST Resource: [v2.projects.instances.clusters.hotTablets](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.hotTablets)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.hotTablets/list` | `GET /v2/{parent=projects/*/instances/*/clusters/*}/hotTablets` Lists hot tablets in a cluster, within the time range provided. |

## REST Resource: [v2.projects.instances.clusters.memoryLayers](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.memoryLayers)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.clusters.memoryLayers/list` | `GET /v2/{parent=projects/*/instances/*/clusters/*}/memoryLayers` Lists information about memory layers. |

## REST Resource: [v2.projects.instances.logicalViews](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.logicalViews)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.logicalViews/create` | `POST /v2/{parent=projects/*/instances/*}/logicalViews` Creates a logical view within an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.logicalViews/delete` | `DELETE /v2/{name=projects/*/instances/*/logicalViews/*}` Deletes a logical view from an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.logicalViews/get` | `GET /v2/{name=projects/*/instances/*/logicalViews/*}` Gets information about a logical view. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.logicalViews/getIamPolicy` | `POST /v2/{resource=projects/*/instances/*/logicalViews/*}:getIamPolicy` Gets the access control policy for an instance resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.logicalViews/list` | `GET /v2/{parent=projects/*/instances/*}/logicalViews` Lists information about logical views in an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.logicalViews/patch` | `PATCH /v2/{logicalView.name=projects/*/instances/*/logicalViews/*}` Updates a logical view within an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.logicalViews/setIamPolicy` | `POST /v2/{resource=projects/*/instances/*/logicalViews/*}:setIamPolicy` Sets the access control policy on an instance resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.logicalViews/testIamPermissions` | `POST /v2/{resource=projects/*/instances/*/logicalViews/*}:testIamPermissions` Returns permissions that the caller has on the specified instance resource. |

## REST Resource: [v2.projects.instances.materializedViews](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.materializedViews)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.materializedViews/create` | `POST /v2/{parent=projects/*/instances/*}/materializedViews` Creates a materialized view within an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.materializedViews/delete` | `DELETE /v2/{name=projects/*/instances/*/materializedViews/*}` Deletes a materialized view from an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.materializedViews/get` | `GET /v2/{name=projects/*/instances/*/materializedViews/*}` Gets information about a materialized view. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.materializedViews/getIamPolicy` | `POST /v2/{resource=projects/*/instances/*/materializedViews/*}:getIamPolicy` Gets the access control policy for an instance resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.materializedViews/list` | `GET /v2/{parent=projects/*/instances/*}/materializedViews` Lists information about materialized views in an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.materializedViews/patch` | `PATCH /v2/{materializedView.name=projects/*/instances/*/materializedViews/*}` Updates a materialized view within an instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.materializedViews/setIamPolicy` | `POST /v2/{resource=projects/*/instances/*/materializedViews/*}:setIamPolicy` Sets the access control policy on an instance resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.materializedViews/testIamPermissions` | `POST /v2/{resource=projects/*/instances/*/materializedViews/*}:testIamPermissions` Returns permissions that the caller has on the specified instance resource. |

## REST Resource: [v2.projects.instances.tables](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/checkConsistency` | `POST /v2/{name=projects/*/instances/*/tables/*}:checkConsistency` Checks replication consistency based on a consistency token, that is, if replication has caught up based on the conditions specified in the token and the check request. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/create` | `POST /v2/{parent=projects/*/instances/*}/tables` Creates a new table in the specified instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/delete` | `DELETE /v2/{name=projects/*/instances/*/tables/*}` Permanently deletes a specified table and all of its data. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/dropRowRange` | `POST /v2/{name=projects/*/instances/*/tables/*}:dropRowRange` Permanently drop/delete a row range from a specified table. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/generateConsistencyToken` | `POST /v2/{name=projects/*/instances/*/tables/*}:generateConsistencyToken` Generates a consistency token for a Table, which can be used in CheckConsistency to check whether mutations to the table that finished before this call started have been replicated. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/get` | `GET /v2/{name=projects/*/instances/*/tables/*}` Gets metadata information about the specified table. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/getIamPolicy` | `POST /v2/{resource=projects/*/instances/*/tables/*}:getIamPolicy` Gets the access control policy for a Bigtable resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/list` | `GET /v2/{parent=projects/*/instances/*}/tables` Lists all tables served from a specified instance. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/modifyColumnFamilies` | `POST /v2/{name=projects/*/instances/*/tables/*}:modifyColumnFamilies` Performs a series of column family modifications on the specified table. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/patch` | `PATCH /v2/{table.name=projects/*/instances/*/tables/*}` Updates a specified table. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/restore` | `POST /v2/{parent=projects/*/instances/*}/tables:restore` Create a new table by restoring from a completed backup. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/setIamPolicy` | `POST /v2/{resource=projects/*/instances/*/tables/*}:setIamPolicy` Sets the access control policy on a Bigtable resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/testIamPermissions` | `POST /v2/{resource=projects/*/instances/*/tables/*}:testIamPermissions` Returns permissions that the caller has on the specified Bigtable resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables/undelete` | `POST /v2/{name=projects/*/instances/*/tables/*}:undelete` Restores a specified table which was accidentally deleted. |

## REST Resource: [v2.projects.instances.tables.authorizedViews](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.authorizedViews)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.authorizedViews/create` | `POST /v2/{parent=projects/*/instances/*/tables/*}/authorizedViews` Creates a new AuthorizedView in a table. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.authorizedViews/delete` | `DELETE /v2/{name=projects/*/instances/*/tables/*/authorizedViews/*}` Permanently deletes a specified AuthorizedView. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.authorizedViews/get` | `GET /v2/{name=projects/*/instances/*/tables/*/authorizedViews/*}` Gets information from a specified AuthorizedView. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.authorizedViews/getIamPolicy` | `POST /v2/{resource=projects/*/instances/*/tables/*/authorizedViews/*}:getIamPolicy` Gets the access control policy for a Bigtable resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.authorizedViews/list` | `GET /v2/{parent=projects/*/instances/*/tables/*}/authorizedViews` Lists all AuthorizedViews from a specific table. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.authorizedViews/patch` | `PATCH /v2/{authorizedView.name=projects/*/instances/*/tables/*/authorizedViews/*}` Updates an AuthorizedView in a table. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.authorizedViews/setIamPolicy` | `POST /v2/{resource=projects/*/instances/*/tables/*/authorizedViews/*}:setIamPolicy` Sets the access control policy on a Bigtable resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.authorizedViews/testIamPermissions` | `POST /v2/{resource=projects/*/instances/*/tables/*/authorizedViews/*}:testIamPermissions` Returns permissions that the caller has on the specified Bigtable resource. |

## REST Resource: [v2.projects.instances.tables.schemaBundles](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.schemaBundles)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.schemaBundles/create` | `POST /v2/{parent=projects/*/instances/*/tables/*}/schemaBundles` Creates a new schema bundle in the specified table. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.schemaBundles/delete` | `DELETE /v2/{name=projects/*/instances/*/tables/*/schemaBundles/*}` Deletes a schema bundle in the specified table. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.schemaBundles/get` | `GET /v2/{name=projects/*/instances/*/tables/*/schemaBundles/*}` Gets metadata information about the specified schema bundle. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.schemaBundles/getIamPolicy` | `POST /v2/{resource=projects/*/instances/*/tables/*/schemaBundles/*}:getIamPolicy` Gets the access control policy for a Bigtable resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.schemaBundles/list` | `GET /v2/{parent=projects/*/instances/*/tables/*}/schemaBundles` Lists all schema bundles associated with the specified table. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.schemaBundles/patch` | `PATCH /v2/{schemaBundle.name=projects/*/instances/*/tables/*/schemaBundles/*}` Updates a schema bundle in the specified table. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.schemaBundles/setIamPolicy` | `POST /v2/{resource=projects/*/instances/*/tables/*/schemaBundles/*}:setIamPolicy` Sets the access control policy on a Bigtable resource. |
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.instances.tables.schemaBundles/testIamPermissions` | `POST /v2/{resource=projects/*/instances/*/tables/*/schemaBundles/*}:testIamPermissions` Returns permissions that the caller has on the specified Bigtable resource. |

## REST Resource: [v2.projects.locations](https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.locations)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/bigtable/docs/reference/admin/rest/v2/projects.locations/list` | `GET /v2/{name=projects/*}/locations` Lists information about the supported locations for this service. |